<?php

require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'includes/class-servicetrade-action.php';
require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'includes/class-servicetrade-user-meta.php';

/**
 * Updates permissions for a user.
 *
 * An action class.
 *
 * @link       http://www.servicetrade.com
 * @since      2.0.0
 * @package    Servicetrade_Service_Portal
 * @subpackage Servicetrade_Service_Portal/public/rest/actions
 * @author     ServiceTrade <support@servicetrade.com>
 */
class Servicetrade_Service_Portal_Admin_Actions_Rest_Users_User_Id_Put_Action extends Servicetrade_Action {
  private $user_id;
  private $canRequestService;
  private $canViewQuotes;
  private $canViewDeficiencies;
  private $canViewPrices;
  
  public function __construct($user_id,
                              $canRequestService,
                              $canViewQuotes,
                              $canViewDeficiencies,
                              $canViewPrices ) {
    $this->user_id = $user_id;
    $this->canRequestService =$canRequestService;
    $this->canViewQuotes = $canViewQuotes;
    $this->canViewDeficiencies = $canViewDeficiencies;
    $this->canViewPrices = $canViewPrices;
  }

  function run() {
    // error_log(print_r($this->canRequestService, TRUE)); 

    
    if(isset($this->canRequestService)) {
      Servicetrade_User_Meta::set_can_request_service($this->user_id, $this->canRequestService);
    }
    if(isset($this->canViewQuotes)) {
      Servicetrade_User_Meta::set_can_view_quotes($this->user_id, $this->canViewQuotes);
    }
    if(isset($this->canViewDeficiencies)) {
      Servicetrade_User_Meta::set_can_view_deficiencies($this->user_id, $this->canViewDeficiencies);
    }
    if(isset($this->canViewPrices)) {
      Servicetrade_User_Meta::set_can_view_prices($this->user_id, $this->canViewPrices);
    }

    return new WP_REST_Response( array(), 200 );
  } 
}
