<?php

require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'includes/models/class-api-credentials.php';
require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'includes/models/class-servicetrade-options.php';
require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'vendor/servicetrade/servicetrade-php/Servicetrade.php';

/**
 * The view model for the add user page
 *
 *
 * @link       http://www.servicetrade.com
 * @since      2.0.0
 * @package    Servicetrade_Service_Portal
 * @subpackage Servicetrade_Service_Portal/admin/view-models
 * @author     ServiceTrade <support@servicetrade.com>
 */
class Servicetrade_Service_Portal_Admin_Page_Add_User_ViewModel {
  public $error = null; // --> Move this into common base class. Might make this readonly function.

	public $username = "";
	public $password = "";
	public $verify_password = ""; 
	public $email = "";

	// TODO --> This needs to be initialized from the settings

	public $featureRequestServiceEnabled = true;
	public $featureViewQuotesEnabled = true;
	public $featureViewDeficienciesEnabled = true;
	public $featureViewPricesEnabled = true;

	// 
	public $featureCanEnableRequestService = false;


  /**
   * Constructs a new object.
   *
   * Specify the input parameters used for the backend queries.
	 *
	 * @since    2.0.0
   * @param    bool      $show_inactive_user True to include inactive users.
	 */
	public function __construct() {
		// @TODO --> Set the disabled correctly.

		$this->featureRequestServiceEnabled = Servicetrade_Models_ServiceTrade_Options::get_request_service();
		$this->featureCanEnableRequestService = Servicetrade_Models_ServiceTrade_Options::get_request_service();
  }

	/**
	 * Initializes the view model for the first time (e.g. GET request)
	 *
	 * @since     2.0.0
	 */
	function load() {
		// Placeholder
  }

	/**
	 * Initializes the view model from a data array, usually the $_POST result.
	 *
	 * This does not perform any validation.
	 * @since     2.0.0
	 */
	function fromData($data) {
		// @TODO --> iterate over this instead!
		// @TODO --> html decoding if necessary

    if(isset($data['username'])) {
      $this->username = $data['username'];
		}
		if(isset($data['email'])) {
      $this->email = $data['email'];
    }
		if(isset($data['password'])) {
      $this->password = $data['password'];
    }
		if(isset($data['verifyPassword'])) {
      $this->verify_password = $data['verifyPassword'];
    }

		//@TODO is this echo supposed to be here?
		if(isset($data['featureRequestServiceEnabled'])) {
			echo($data['featureRequestServiceEnabled']);
		}

		$this->featureRequestServiceEnabled = Servicetrade_Models_ServiceTrade_Options::get_request_service() && 
																					isset($data['featureRequestServiceEnabled']) && $data['featureRequestServiceEnabled'] == 'on';
		
		$this->featureViewQuotesEnabled = isset($data['featureViewQuotesEnabled']) && $data['featureViewQuotesEnabled'] == 'on';
		$this->featureViewDeficienciesEnabled = isset($data['featureViewDeficienciesEnabled']) && $data['featureViewDeficienciesEnabled'] == 'on';
		$this->featureViewPricesEnabled = isset($data['featureViewPricesEnabled']) && $data['featureViewPricesEnabled'] == 'on';
	}

	/**
	 * Validates the contents of the view model, sets the error object, and returns the validation state.
	 *
	 * @since     2.0.0
	 * @return    bool    True when valid; otherwise false
	 */
	function validate() {
		return true;
	}


}
