<?php

require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'includes/class-servicetrade-action.php';
require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'includes/class-servicetrade-helper-sideloadmapper.php';
require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'public/rest/class-public-rest-action.php';

/**
 * Returns a single location.
 *
 * An action class.
 *
 * @link       http://www.servicetrade.com
 * @since      2.0.0
 * @package    Servicetrade_Service_Portal
 * @subpackage Servicetrade_Service_Portal/public/rest/actions
 * @author     ServiceTrade <support@servicetrade.com>
 */
class Servicetrade_Service_Portal_Public_Actions_Rest_Job_Types_For_Select_Get_Action extends Servicetrade_Service_Portal_Public_Rest_Action {
  private $includeAll;
  
  public function __construct($includeAll ) {
    $this->includeAll = $includeAll;

  }

  function run() {

	  // there's no API resource for returning your account's job types, so for now we just return a hardcoded list
	  $rawJobTypes = [
		  "cleaning",
		  "construction",
		  "delivery",
		  "emergency_service_call",
		  "exchange",
		  "installation",
		  "inspection",
		  "pickup",
		  "priority_inspection",
		  "preventative_maintenance",
		  "priority_service_call",
		  "quality_assurance",
		  "repair",
		  "sales",
		  "service_call",
		  "survey",
		  "upgrade",
		  "urgent_service_call",
		  "warranty"
	  ];

    if($this->includeAll) {
      $mappedResults[] = array(
        'value' => null,
        'label' => '-- All Job Types --',
      );
    }

    foreach ($rawJobTypes as $jobtype) {
      $mappedResults[] = array(
        'value' => $jobtype,
        'label' => ucwords( str_replace("_", " ", $jobtype))
      );
    }

    return new WP_REST_Response( $mappedResults, 200 );
  }
}
