<?php

/**
 * Represents the current timezone
 *
 * Used to retrieve the current timezone and also adjusts the date.
 *
 * @link       http://www.servicetrade.com
 * @since      2.0.0
 * @package    Servicetrade_Service_Portal
 * @subpackage Servicetrade_Service_Portal/public/rest
 * @author     ServiceTrade <support@servicetrade.com>
 * @example
 */

class Servicetrade_Service_Portal_Public_Current_Timezone {
  public $todayStart;
  public $todayEnd;
  public $recently;

  /**
  * Returns the timezone class.
  */
  public static function timezone() {
    $timezone = new Servicetrade_Service_Portal_Public_Current_Timezone();

    // @TODO -> Get the timezone from the options.
    // $sttimezone = $stp->get_timezone() ?: 'America/New_York';
    $sttimezone = 'America/New_York';
    date_default_timezone_set($sttimezone);

    $timezone->todayStart = strtotime('midnight today');
    $timezone->todayEnd = $timezone->tomorrowStart = strtotime('midnight tomorrow');
    $timezone->todayEnd--; // one second before midnight
    $timezone->recently = strtotime('-90 days');

    return $timezone;
  }


}
